Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0000769Core InformKinds and type checkingpublic2011-10-04 04:042014-05-07 07:33
ReporterChrisC 
Assigned Tograham 
PrioritynormalSeveritymildReproducibilityalways
StatusclosedResolutionfixed 
Platformx86OSWindowsOS Version7
Product Version6G60 
Target VersionFixed in Version6L02 
Summary0000769: NI allows author to define a new kind of value with same name as an existing rulebook.
DescriptionThis one took me a long time to figure out exactly what was going on. If you try to create a new kind of value with the same name as a rulebook, NI doesn't complain. If you then attempt to define the acceptable range of values, the problem message produced says "I am reading 'persuasions' and 'convinced' as two different things, and therefore it makes no sense to say that one is the other".

The problem doesn't actually lie in this line at all, but in the previous one, where the new kind of value was created. NI should recognize the namespace clash and disallow the new kind of value from being created -- or else allow it to be created and not get confused by the value-enumeration line.
Minimal Source Text To Reproduce
This is a room.

A persuasion is a kind of value. [No problem message.]

[The persuasions are convinced, leaning, and unconvinced.] [Uncommenting this line produces the following 
problem message:]
Additional InformationThis is the report produced by Inform 7 (build 6G60) on its most recent run through:

Problem. The sentence 'The persuasions are convinced, leaning, and unconvinced' appears to say two things are the same - I am reading 'persuasions' and 'convinced' as two different things, and therefore it makes no sense to say that one is the other: it would be like saying that 'Tom is Jerry'. It would be all right if the second thing were the name of a kind, perhaps with properties: for instance 'Mouse-Hole is a lighted room' says that something called Mouse-Hole exists and that it is a 'room', which is a kind I know about, combined with a property called 'lighted' which I also know about.
TagsNo tags attached.
Effect(mild) Compiler accepts invalid code
Attached Files

- Relationships

-  Notes
(0001315)
Ron Newcomb (reporter)
2011-10-05 23:12

I see that problem message a lot. It would be nice if it would at least say what the "two different things" are. Many problem messages will have a list after the message saying things like:

    x - a number
    y - an instruction to work out a number, which results in a number
    z - something unrecognized

...but this Problem message doesn't do that.
(0001318)
ChrisC (reporter)
2011-10-06 07:11

Yes, that would be a very helpful addition to the Problem message. I meant to mention that in my description, thank you.
(0002430)
graham (administrator)
2014-02-01 13:14

Fixed.

I've also improved the problem message discussed here - the ever-popular "two things are the same" one. In almost all cases it occurs when the two things were created by that very sentence, so that there's no further information to give, but in cases where one already exists, it's more informative.

- Issue History
Date Modified Username Field Change
2011-10-04 04:04 ChrisC New Issue
2011-10-05 23:12 Ron Newcomb Note Added: 0001315
2011-10-06 07:11 ChrisC Note Added: 0001318
2011-10-07 08:34 EmacsUser Status new => confirmed
2014-02-01 13:14 graham Note Added: 0002430
2014-02-01 13:14 graham Status confirmed => resolved
2014-02-01 13:14 graham Resolution open => fixed
2014-02-01 13:14 graham Assigned To => graham
2014-05-07 07:32 jmcgrew Fixed in Version => 6L02
2014-05-07 07:33 jmcgrew Status resolved => closed


Copyright © 2000 - 2010 MantisBT Group
Powered by Mantis Bugtracker